<template>
<div class="plugin_container">
  <div id="plugin_container_top_left">
    <div v-for="plugin in pluginsTL" :key="plugin.id">
      <component v-if="plugin.isActive"
      v-bind:is="plugin.componentName" :plugin="plugin"></component>
    </div>
  </div>
  <div id="plugin_container_top_right">
    <div v-for="plugin in pluginsTR" :key="plugin.id">
      <component v-if="plugin.isActive"
      v-bind:is="plugin.componentName" :plugin="plugin"></component>
    </div>
  </div>
  <div id="plugin_container_bottom_left">
    <div v-for="plugin in pluginsBL" :key="plugin.id"  class="bottom_plugin_div">
      <component v-if="plugin.isActive"
      v-bind:is="plugin.componentName" :plugin="plugin"></component>
    </div>
  </div>
  <div id="plugin_container_bottom_right">
    <div v-for="plugin in pluginsBR" :key="plugin.id" class="bottom_plugin_div">
      <component v-if="plugin.isActive"
      v-bind:is="plugin.componentName" :plugin="plugin"></component>
    </div>
  </div>
</div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import ApiAdressePlugin from '@/components/plugins/ApiAdressePlugin.vue';
import MousePositionPlugin from '@/components/plugins/openlayers/MousePositionPlugin.vue';
import ScalePlugin from '@/components/plugins/openlayers/ScalePlugin.vue';
import MesurePlugin from '@/components/plugins/openlayers/MesurePlugin.vue';
import LoadingInfosPlugin from '@/components/plugins/openlayers/LoadingInfosPlugin.vue';
import { PluginLocation } from '@/models/plugin/PluginLocation';
import Plugin from '@/models/plugin/Plugin';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';
import ScaleListPlugin from '../plugins/ScaleListPlugin.vue';
import NavigationPlugin from '../plugins/openlayers/NavigationPlugin.vue';
import MapillaryPlugin from '../plugins/MapillaryPlugin.vue';
import CesiumPlugin from '../plugins/CesiumPlugin.vue';

@Component({
  props: {
  },
  components: {
    ApiAdressePlugin,
    MousePositionPlugin,
    LoadingInfosPlugin,
    MesurePlugin,
    ScalePlugin,
    ScaleListPlugin,
    NavigationPlugin,
    MapillaryPlugin,
    CesiumPlugin,
  },
})
export default class MapPluginContainer extends BaseComponent {
    pluginsBR:Plugin[]=[];

    pluginsBL:Plugin[]=[];

    pluginsTL:Plugin[]=[];

    pluginsTR:Plugin[]=[];

    mounted() {
      // eslint-disable-next-line prefer-template
      console.log('Mount plugin components' + PluginLocation.TopLeft);
      this.pluginsTL = this.pluginService.plugins.filter(
        (x:Plugin) => x.configuration.position === PluginLocation.TopLeft,
      );

      this.pluginsTR = this.pluginService.plugins.filter(
        (x:Plugin) => x.configuration.position === PluginLocation.TopRight,
      );

      this.pluginsBR = this.pluginService.plugins.filter(
        (x:Plugin) => x.configuration.position === PluginLocation.BottomRight,
      );

      this.pluginsBL = this.pluginService.plugins.filter(
        (x:Plugin) => x.configuration.position === PluginLocation.BottomLeft,
      );
    }
}
</script>

<style scoped lang="less">
.plugin_container{
  flex-grow: 1;
  display: flex;
  flex-wrap: wrap;
}

#plugin_container_top_left{
   flex: 50%;
   padding-top:15px;
   padding-left:15px;
   /*
  position:absolute;
  top:10px;
  left:150px;*/
  display: flex;
}
#plugin_container_top_right{
  flex: 50%;
  text-align: right;
/*
  position:absolute;
  top:10px;
  right:50px;*/
  display: flex;
  flex-direction: row-reverse;
  padding-right: 15px;
  padding-top: 15px;
}
#plugin_container_bottom_right{
  /*position:absolute;
  bottom:0px;
  right:50px;*/
  width:50%;
  flex: 50%;
  margin-top: auto;
  text-align: right;
  display: flex;
}
#plugin_container_bottom_left{
  /*position:absolute;
  bottom:0px;
  left:150px;*/
  width:50%;
  margin-top: auto;
  flex: 50%;
  display: flex;
}

.bottom_plugin_div{
  margin-top: auto;
}
</style>
